/*
IBM Confidential

OCO Source Materials

5630-A36

(c) Copyright IBM Corp. 1992, 2002

The source code for this program is not published or other-
wise divested of its trade secrets, irrespective of what has
been deposited with the U.S. Copyright Office.
*/

#ifndef JAVELIN_PROXY_H
#define JAVELIN_PROXY_H

#ifndef HTAPI_H
#include "HTAPI.h"
#endif


/* Long name to short name mapping */
#define HTTPD_parse_rule     JPARSRUL
#define HTTPD_supply_rule    JSUPRUL
#define HTTPD_free_rule      JFRERUL

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Parse a PicsRULZ rule and return a handle to it. Only valid
 * during the PicsRuleLookup step.
 */
void
HTTPD_LINKAGE
HTTPD_parse_rule(
    unsigned char *handle,           /* i; handle from ICAPI */
    unsigned char *rule,             /* i; text of the rule */
    unsigned long *rule_length,      /* i; length of the rule */
    unsigned long *rule_handle,      /* o; rule handle */
             long *return_code);     /* o; return code */

/* Tell the PICS filtering component which preparsed rule to use for
 * the current request. Valid only during the PicsRuleLookup step.
 */
void
HTTPD_LINKAGE
HTTPD_supply_rule(
    unsigned char *handle,           /* i; handle from ICAPI */
    unsigned long *rule_handle,      /* i; rule handle */
             long *return_code);     /* o; return code */


/* Free a parsed PicsRULZ rule that was parsed by HTTPD_parse_rule.
 * Valid during PicsRuleLookup and ServerTerm steps.
 */
void
HTTPD_LINKAGE
HTTPD_free_rule(
    unsigned char *handle,           /* i; handle from ICAPI */
    unsigned long *rule_handle,      /* i; rule handle */
             long *return_code);     /* o; return code */

void JavelinAPI_init(BOOL firstTime);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* HTAPI_H */
